package org.eclipse.xtext.example.domainmodel.tests

import com.google.inject.Inject
import org.eclipse.xtext.example.domainmodel.domainmodel.DomainModel
import org.eclipse.xtext.junit4.InjectWith
import org.eclipse.xtext.junit4.XtextRunner
import org.eclipse.xtext.junit4.util.ParseHelper
import org.junit.Test
import org.junit.runner.RunWith
import org.eclipse.xtext.junit4.validation.ValidationTestHelper

@RunWith(typeof(XtextRunner))
@InjectWith(typeof(InjectorProviderCustom))
class ParserTest {
	
	@Inject extension ParseHelper<DomainModel>
	@Inject extension ValidationTestHelper

	@Test
	def void testParsing() {
		'''
			package example {
			  entity MyEntity {
			    property : String
			
			    xmlgenerator generator1 {
			      <MyEntity>
			        <Property>
			          property
			        </Property>
			      </MyEntity>
				}
			  }
			}
		'''.parse.assertNoErrors
	}
}