/*******************************************************************************
 * Copyright (c) 2012 itemis AG (http://www.itemis.eu) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package org.eclipse.xtext.example.domainmodel.scope;

import java.util.Collections;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.xtext.example.domainmodel.domainmodel.DomainmodelPackage;
import org.eclipse.xtext.example.domainmodel.domainmodel.XmlTag;
import org.eclipse.xtext.scoping.IScope;
import org.eclipse.xtext.scoping.Scopes;
import org.eclipse.xtext.xbase.scoping.XbaseScopeProvider;

/**
 * @author boris - Initial contribution and API
 */
public class MyScopeProvider extends XbaseScopeProvider {
	@Override
	public IScope getScope(EObject context, EReference reference) {
		if (context instanceof XmlTag && reference.equals(DomainmodelPackage.Literals.XML_TAG__END_TAG_NAME)) {
			return Scopes.scopeFor(Collections.singleton(context));
		}
		return super.getScope(context, reference);
	}
}
