package org.eclipse.xtext.example.domainmodel.jvmmodel;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import java.util.ArrayList;
import java.util.Arrays;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.common.types.JvmConstructor;
import org.eclipse.xtext.common.types.JvmField;
import org.eclipse.xtext.common.types.JvmFormalParameter;
import org.eclipse.xtext.common.types.JvmGenericType;
import org.eclipse.xtext.common.types.JvmMember;
import org.eclipse.xtext.common.types.JvmOperation;
import org.eclipse.xtext.common.types.JvmParameterizedTypeReference;
import org.eclipse.xtext.common.types.JvmTypeReference;
import org.eclipse.xtext.example.domainmodel.domainmodel.Entity;
import org.eclipse.xtext.example.domainmodel.domainmodel.Feature;
import org.eclipse.xtext.example.domainmodel.domainmodel.Operation;
import org.eclipse.xtext.example.domainmodel.domainmodel.Property;
import org.eclipse.xtext.example.domainmodel.domainmodel.XmlBlock;
import org.eclipse.xtext.example.domainmodel.domainmodel.XmlContent;
import org.eclipse.xtext.example.domainmodel.domainmodel.XmlGenerator;
import org.eclipse.xtext.example.domainmodel.domainmodel.XmlTag;
import org.eclipse.xtext.example.domainmodel.domainmodel.XmlTags;
import org.eclipse.xtext.naming.IQualifiedNameProvider;
import org.eclipse.xtext.naming.QualifiedName;
import org.eclipse.xtext.xbase.XExpression;
import org.eclipse.xtext.xbase.compiler.TypeReferenceSerializer;
import org.eclipse.xtext.xbase.compiler.output.ITreeAppendable;
import org.eclipse.xtext.xbase.jvmmodel.AbstractModelInferrer;
import org.eclipse.xtext.xbase.jvmmodel.IJvmDeclaredTypeAcceptor;
import org.eclipse.xtext.xbase.jvmmodel.IJvmDeclaredTypeAcceptor.IPostIndexingInitializing;
import org.eclipse.xtext.xbase.jvmmodel.JvmTypesBuilder;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.Functions.Function2;
import org.eclipse.xtext.xbase.lib.IntegerRange;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class DomainmodelJvmModelInferrer extends AbstractModelInferrer {
  @Inject
  private TypeReferenceSerializer _typeReferenceSerializer;
  
  @Inject
  private JvmTypesBuilder _jvmTypesBuilder;
  
  @Inject
  private IQualifiedNameProvider _iQualifiedNameProvider;
  
  protected void _infer(final Entity entity, final IJvmDeclaredTypeAcceptor acceptor, final boolean prelinkingPhase) {
    QualifiedName _fullyQualifiedName = this._iQualifiedNameProvider.getFullyQualifiedName(entity);
    JvmGenericType _class = this._jvmTypesBuilder.toClass(entity, _fullyQualifiedName);
    IPostIndexingInitializing<JvmGenericType> _accept = acceptor.<JvmGenericType>accept(_class);
    final Procedure1<JvmGenericType> _function = new Procedure1<JvmGenericType>() {
        public void apply(final JvmGenericType it) {
          String _documentation = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.getDocumentation(entity);
          DomainmodelJvmModelInferrer.this._jvmTypesBuilder.setDocumentation(it, _documentation);
          JvmParameterizedTypeReference _superType = entity.getSuperType();
          boolean _notEquals = (!Objects.equal(_superType, null));
          if (_notEquals) {
            EList<JvmTypeReference> _superTypes = it.getSuperTypes();
            JvmParameterizedTypeReference _superType_1 = entity.getSuperType();
            JvmTypeReference _cloneWithProxies = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.cloneWithProxies(_superType_1);
            DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmTypeReference>operator_add(_superTypes, _cloneWithProxies);
          }
          JvmTypeReference _newTypeRef = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.newTypeRef(it);
          final JvmTypeReference procedure = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.newTypeRef(entity, Procedure1.class, _newTypeRef);
          EList<JvmMember> _members = it.getMembers();
          final Procedure1<JvmConstructor> _function = new Procedure1<JvmConstructor>() {
              public void apply(final JvmConstructor it) {
              }
            };
          JvmConstructor _constructor = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toConstructor(entity, _function);
          DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmConstructor>operator_add(_members, _constructor);
          EList<JvmMember> _members_1 = it.getMembers();
          final Procedure1<JvmConstructor> _function_1 = new Procedure1<JvmConstructor>() {
              public void apply(final JvmConstructor it) {
                EList<JvmFormalParameter> _parameters = it.getParameters();
                JvmFormalParameter _parameter = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toParameter(entity, "initializer", procedure);
                DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmFormalParameter>operator_add(_parameters, _parameter);
                final Procedure1<ITreeAppendable> _function = new Procedure1<ITreeAppendable>() {
                    public void apply(final ITreeAppendable it) {
                      it.append("initializer.apply(this);");
                    }
                  };
                DomainmodelJvmModelInferrer.this._jvmTypesBuilder.setBody(it, _function);
              }
            };
          JvmConstructor _constructor_1 = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toConstructor(entity, _function_1);
          DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmConstructor>operator_add(_members_1, _constructor_1);
          final ArrayList<JvmField> fields = CollectionLiterals.<JvmField>newArrayList();
          EList<Feature> _features = entity.getFeatures();
          for (final Feature f : _features) {
            boolean _matched = false;
            if (!_matched) {
              if (f instanceof Property) {
                final Property _property = (Property)f;
                _matched=true;
                String _name = _property.getName();
                JvmTypeReference _type = _property.getType();
                final JvmField field = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toField(_property, _name, _type);
                fields.add(field);
                EList<JvmMember> _members_2 = it.getMembers();
                DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmField>operator_add(_members_2, field);
                EList<JvmMember> _members_3 = it.getMembers();
                String _name_1 = _property.getName();
                JvmTypeReference _type_1 = _property.getType();
                JvmOperation _getter = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toGetter(_property, _name_1, _type_1);
                DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmOperation>operator_add(_members_3, _getter);
                EList<JvmMember> _members_4 = it.getMembers();
                String _name_2 = _property.getName();
                JvmTypeReference _type_2 = _property.getType();
                JvmOperation _setter = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toSetter(_property, _name_2, _type_2);
                DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmOperation>operator_add(_members_4, _setter);
              }
            }
            if (!_matched) {
              if (f instanceof Operation) {
                final Operation _operation = (Operation)f;
                _matched=true;
                EList<JvmMember> _members_2 = it.getMembers();
                String _name = _operation.getName();
                JvmTypeReference _type = _operation.getType();
                final Procedure1<JvmOperation> _function_2 = new Procedure1<JvmOperation>() {
                    public void apply(final JvmOperation it) {
                      String _documentation = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.getDocumentation(_operation);
                      DomainmodelJvmModelInferrer.this._jvmTypesBuilder.setDocumentation(it, _documentation);
                      EList<JvmFormalParameter> _params = _operation.getParams();
                      for (final JvmFormalParameter p : _params) {
                        EList<JvmFormalParameter> _parameters = it.getParameters();
                        String _name = p.getName();
                        JvmTypeReference _parameterType = p.getParameterType();
                        JvmFormalParameter _parameter = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toParameter(p, _name, _parameterType);
                        DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmFormalParameter>operator_add(_parameters, _parameter);
                      }
                      XExpression _body = _operation.getBody();
                      DomainmodelJvmModelInferrer.this._jvmTypesBuilder.setBody(it, _body);
                    }
                  };
                JvmOperation _method = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toMethod(_operation, _name, _type, _function_2);
                DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmOperation>operator_add(_members_2, _method);
              }
            }
            if (!_matched) {
              if (f instanceof XmlGenerator) {
                final XmlGenerator _xmlGenerator = (XmlGenerator)f;
                _matched=true;
                EList<JvmMember> _members_2 = it.getMembers();
                String _name = _xmlGenerator.getName();
                String _plus = (_name + "XmlGenerator");
                JvmTypeReference _newTypeRef_1 = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.newTypeRef(_xmlGenerator, String.class);
                final Procedure1<JvmOperation> _function_2 = new Procedure1<JvmOperation>() {
                    public void apply(final JvmOperation it) {
                      String _documentation = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.getDocumentation(_xmlGenerator);
                      DomainmodelJvmModelInferrer.this._jvmTypesBuilder.setDocumentation(it, _documentation);
                      final Procedure1<ITreeAppendable> _function = new Procedure1<ITreeAppendable>() {
                          public void apply(final ITreeAppendable it) {
                            final String varName = it.declareVariable(DomainmodelJvmModelInferrer.this, "sb");
                            ITreeAppendable t = it.trace(_xmlGenerator, true);
                            JvmTypeReference _newTypeRef = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.newTypeRef(_xmlGenerator, StringBuilder.class);
                            DomainmodelJvmModelInferrer.this._typeReferenceSerializer.serialize(_newTypeRef, _xmlGenerator, t);
                            StringConcatenation _builder = new StringConcatenation();
                            _builder.append(" ");
                            _builder.append(varName, " ");
                            _builder.append(" = new ");
                            t.append(_builder);
                            JvmTypeReference _newTypeRef_1 = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.newTypeRef(_xmlGenerator, StringBuilder.class);
                            DomainmodelJvmModelInferrer.this._typeReferenceSerializer.serialize(_newTypeRef_1, _xmlGenerator, t);
                            StringConcatenation _builder_1 = new StringConcatenation();
                            _builder_1.append(" ");
                            _builder_1.append("();");
                            ITreeAppendable _append = t.append(_builder_1);
                            _append.newLine();
                            XmlBlock _block = _xmlGenerator.getBlock();
                            DomainmodelJvmModelInferrer.this.inferXml(it, _block, 0);
                            ITreeAppendable _trace = it.trace(_xmlGenerator);
                            StringConcatenation _builder_2 = new StringConcatenation();
                            _builder_2.append("return ");
                            _builder_2.append(varName, "");
                            _builder_2.append(".toString();");
                            ITreeAppendable _append_1 = _trace.append(_builder_2);
                            _append_1.newLine();
                          }
                        };
                      DomainmodelJvmModelInferrer.this._jvmTypesBuilder.setBody(it, _function);
                    }
                  };
                JvmOperation _method = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toMethod(_xmlGenerator, _plus, _newTypeRef_1, _function_2);
                DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmOperation>operator_add(_members_2, _method);
              }
            }
          }
          EList<JvmMember> _members_2 = it.getMembers();
          JvmOperation _toStringMethod = DomainmodelJvmModelInferrer.this._jvmTypesBuilder.toToStringMethod(entity, it);
          DomainmodelJvmModelInferrer.this._jvmTypesBuilder.<JvmOperation>operator_add(_members_2, _toStringMethod);
        }
      };
    _accept.initializeLater(_function);
  }
  
  protected void _inferXml(final ITreeAppendable it, final XmlTags tags, final int indentation) {
    EList<XmlTag> _tags = tags.getTags();
    for (final XmlTag tag : _tags) {
      {
        ITreeAppendable t = it.trace(tag, true);
        this.indent(t, indentation);
        StringConcatenation _builder = new StringConcatenation();
        _builder.append("\"<");
        String _name = tag.getName();
        _builder.append(_name, "");
        _builder.append(">\"");
        this.outputln(t, _builder.toString());
        XmlBlock _block = tag.getBlock();
        int _plus = (indentation + 1);
        this.inferXml(it, _block, _plus);
        ITreeAppendable _trace = it.trace(tag);
        this.indent(_trace, indentation);
        ITreeAppendable _trace_1 = it.trace(tag);
        StringConcatenation _builder_1 = new StringConcatenation();
        _builder_1.append("\"</");
        String _name_1 = tag.getName();
        _builder_1.append(_name_1, "");
        _builder_1.append(">\"");
        this.outputln(_trace_1, _builder_1.toString());
      }
    }
  }
  
  protected void _inferXml(final ITreeAppendable it, final XmlContent content, final int indentation) {
    final ITreeAppendable t = it.trace(content, true);
    this.indent(t, indentation);
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("this.");
    Property _property = content.getProperty();
    String _name = _property.getName();
    _builder.append(_name, "");
    this.outputln(t, _builder.toString());
  }
  
  public ITreeAppendable indent(final ITreeAppendable it, final int indentation) {
    ITreeAppendable _xblockexpression = null;
    {
      IntegerRange _upTo = new IntegerRange(0, indentation);
      final Function1<Integer,String> _function = new Function1<Integer,String>() {
          public String apply(final Integer it) {
            return "";
          }
        };
      Iterable<String> _map = IterableExtensions.<Integer, String>map(_upTo, _function);
      final Function2<String,String,String> _function_1 = new Function2<String,String,String>() {
          public String apply(final String result, final String next) {
            String _plus = (result + "  ");
            return _plus;
          }
        };
      final String spaces = IterableExtensions.<String>reduce(_map, _function_1);
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("\"");
      _builder.append(spaces, "");
      _builder.append("\"");
      ITreeAppendable _output = this.output(it, _builder.toString());
      _xblockexpression = (_output);
    }
    return _xblockexpression;
  }
  
  public ITreeAppendable outputln(final ITreeAppendable it, final String content) {
    ITreeAppendable _xblockexpression = null;
    {
      final String varName = it.getName(this);
      StringConcatenation _builder = new StringConcatenation();
      _builder.append(varName, "");
      _builder.append(".append(");
      _builder.append(content, "");
      _builder.append(");");
      ITreeAppendable _append = it.append(_builder);
      _append.newLine();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append(varName, "");
      _builder_1.append(".append(\"\\n\");");
      ITreeAppendable _append_1 = it.append(_builder_1);
      _append_1.newLine();
      StringConcatenation _builder_2 = new StringConcatenation();
      _builder_2.append("System.out.println(");
      _builder_2.append(content, "");
      _builder_2.append(");");
      ITreeAppendable _append_2 = it.append(_builder_2);
      ITreeAppendable _newLine = _append_2.newLine();
      _xblockexpression = (_newLine);
    }
    return _xblockexpression;
  }
  
  public ITreeAppendable output(final ITreeAppendable it, final String content) {
    ITreeAppendable _xblockexpression = null;
    {
      final String varName = it.getName(this);
      StringConcatenation _builder = new StringConcatenation();
      _builder.append(varName, "");
      _builder.append(".append(");
      _builder.append(content, "");
      _builder.append(");");
      ITreeAppendable _append = it.append(_builder);
      _append.newLine();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("System.out.print(");
      _builder_1.append(content, "");
      _builder_1.append(");");
      ITreeAppendable _append_1 = it.append(_builder_1);
      ITreeAppendable _newLine = _append_1.newLine();
      _xblockexpression = (_newLine);
    }
    return _xblockexpression;
  }
  
  public void infer(final EObject entity, final IJvmDeclaredTypeAcceptor acceptor, final boolean prelinkingPhase) {
    if (entity instanceof Entity) {
      _infer((Entity)entity, acceptor, prelinkingPhase);
      return;
    } else if (entity != null) {
      _infer(entity, acceptor, prelinkingPhase);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(entity, acceptor, prelinkingPhase).toString());
    }
  }
  
  public void inferXml(final ITreeAppendable it, final XmlBlock content, final int indentation) {
    if (content instanceof XmlContent) {
      _inferXml(it, (XmlContent)content, indentation);
      return;
    } else if (content instanceof XmlTags) {
      _inferXml(it, (XmlTags)content, indentation);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it, content, indentation).toString());
    }
  }
}
